{ -----------------------------------------------------------------------------
   MouseOffRoad - Mouse Counter for Microsoft Windows.
   Copyright (C) 2000  Alexander Kramarenko <groupstudio@mail.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

History:
   14.05.2000 Released under GNU
   15.05.2000 ColorSch-support added
------------------------------------------------------------------------------ }

unit uCfg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, uCfgFmt, ComCtrls, Mask, ToolEdit, ExtCtrls, CurrEdit,
  RXSpin, ShellApi;

type
  TfCfg = class(TForm)
    Button1: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    SB: TSpeedButton;
    Label2: TLabel;
    eSlp: TEdit;
    TabSheet4: TTabSheet;
    Label8: TLabel;
    Bevel2: TBevel;
    Label6: TLabel;
    Label7: TLabel;
    Label15: TLabel;
    AutSv: TRxSpinEdit;
    eResultFmt: TEdit;
    eSaveResult: TFilenameEdit;
    TabSheet5: TTabSheet;
    Label9: TLabel;
    Image1: TImage;
    Bevel1: TBevel;
    Label1: TLabel;
    MsRes: TStaticText;
    cblay: TCheckBox;
    Button2: TButton;
    transp: TRxSpinEdit;
    Button3: TButton;
    Label3: TLabel;
    Bevel3: TBevel;
    AKmailto: TLabel;
    Label5: TLabel;
    Label10: TLabel;
    VBmailto: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    SpeedButton2: TSpeedButton;
    Label14: TLabel;
    OEMCvt: TCheckBox;
    cAutRn: TCheckBox;
    Label4: TLabel;
    eColorSch: TRxSpinEdit;
    procedure SBClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure transpChange(Sender: TObject);
    procedure cblayClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure AKmailtoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateAll;
  end;

var upd: boolean;

implementation

uses uVariables, uMain;

{$R *.DFM}

procedure TfCfg.SBClick(Sender: TObject);
const f : single = 1;
begin
   FirstRun := False;
   with TfCfgFmt.Create(nil) do
    try
     if ShowModal = mrOk then
      begin
       if PixelsPerEd = 0 then
        ShowMessage('  .     .')
       else
        DistCoof := 1/PixelsPerEd;
      end;
    finally
     Free;
    end;

    UpdateAll;
end;

procedure TfCfg.Button1Click(Sender: TObject);
begin
     SleepTime := StrToIntDef(eSlp.Text,2);
     SaveResult := eSaveResult.Text;
     ResultFormat := eResultFmt.Text;
     SaveConf := Trunc(AutSv.Value);
     SleepTime := StrToIntDef(eSlp.Text, 2);
     TranspPerc := Trunc(transp.value);
     OemConv := OemCvt.Checked;
     AutoRun := cAutRn.Checked;
     ColorSch := Trunc(eColorSch.Value);
     ModalResult := mrOk;
end;

procedure TfCfg.UpdateAll;
begin
   MsRes.Caption := Format('%.6f', [DistCoof]);
   eSlp.Text := IntToStr(SleepTime);
   eSaveResult.Text := SaveResult;
   eResultFmt.Text := ResultFormat;
   AutSv.Value := SaveConf;
   transp.value := TranspPerc;
   OemCvt.Checked := OemConv;
   cblay.Checked := transp.value <> 100;
   eColorSch.Value := ColorSch;
   cAutRn.Checked := Autorun;
end;

procedure TfCfg.FormShow(Sender: TObject);
begin
     UpdateAll;
     if FirstRun then SBClick(self);
end;

procedure TfCfg.Button2Click(Sender: TObject);
begin
     ModalResult := mrCancel;
end;

procedure TfCfg.transpChange(Sender: TObject);
begin
   if (not upd) then
    try
     upd := true;
     cblay.Checked := (transp.value <> 100);
    finally
     upd := false;
    end;
end;

procedure TfCfg.cblayClick(Sender: TObject);
begin
   if (not upd) then
    try
     upd := true;
     if cblay.checked then transp.value := 60
                      else transp.value := 100;
    finally
     upd := false;
    end;
end;

procedure TfCfg.Button3Click(Sender: TObject);
begin
     if MessageDlg('      ?',
                   mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
     Distance := 1;
     TotalTime := 1;  
end;

procedure TfCfg.SpeedButton2Click(Sender: TObject);
begin
   ShowMessage(
   '    2:5019/10 :'#10#10+
   ' Anatoly Sennov (/10.1) -  ,    ;-)'#10+
   ' Yura Tsvetkov (/10.22) -    OS/2 :)'#10+
   ' Leonid Bondarenko (/10.8) -  '#10+
   ' Alexander Novikov (/10.24) -  '#10+
   ' Renat Bahtijarov (/10.67) -      '#10+
   ' Kostya Rohlin (/10.74) -    , , .'#10#10+
   'MouseOffRoad, Copyright(c) by AK, Russia, Smolensk, 2000');
end;

procedure TfCfg.AKmailtoClick(Sender: TObject);
begin
  ShellExecute(Application.Handle,'open',PChar(TControl(Sender).Hint),
       nil,nil,0);
end;

initialization
  upd := false;
end.
