{ -----------------------------------------------------------------------------
   MouseOffRoad - Mouse Counter for Microsoft Windows.
   Copyright (C) 2000  Alexander Kramarenko <groupstudio@mail.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

History:
   14.05.2000 Released under GNU
   15.05.2000 Bug fixes
------------------------------------------------------------------------------ }

unit uCfgFmt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, AKTools, ExtCtrls, Buttons, uVariables, Mask,
  ToolEdit, CurrEdit;

resourceString
 Txt = '  "!"    ,   %s.      10 .';


type
  TfCfgFmt = class(TForm)
    NB: TNotebook;
    Button1: TButton;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Bevel2: TBevel;
    Bevel3: TBevel;
    StaticText3: TStaticText;
    Image2: TImage;
    PixDn: TLabel;
    Label2: TLabel;
    PB: TProgressBar;
    ID: TLabel;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    Label1: TLabel;
    MouseRes: TStaticText;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Panel1: TPanel;
    Image1: TImage;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    fPixels : Integer;
    fFormat : String;
    DoCalibrate : Boolean;
    { Private declarations }
  public
    property PixelsPerEd: Integer read fPixels;
    procedure Calibrate;
    { Public declarations }
  end;

var
  fCfgFmt: TfCfgFmt;

implementation

{$R *.DFM}

procedure TfCfgFmt.Button1Click(Sender: TObject);
begin
   NB.PageIndex := 1;
   Calibrate;
end;

procedure TfCfgFmt.Button2Click(Sender: TObject);
begin
     DoCalibrate := False;
     ModalResult := mrCancel;
end;

procedure TfCfgFmt.Button5Click(Sender: TObject);
begin
   DoCalibrate := False;
   NB.PageIndex := 0;
end;

procedure TfCfgFmt.Button4Click(Sender: TObject);
begin
   DoCalibrate := False;
   NB.PageIndex := 2;
end;

procedure TfCfgFmt.Calibrate;
var tcSt, i : Integer;
    dst, TotalDst : Integer;
    cx, cy, pX1, pY1 : Integer;
    sp, p : TPoint;
begin
   try
    DoCalibrate := True;
    PixDn.Caption := '0';
    cx := Trunc(Screen.Width/2); cy := Trunc(Screen.Height/2);
    ID.Visible := True;
    for i := 3 downto 0 do
     begin
      ID.Caption := IntToStr(i);
      Application.ProcessMessages;
      Sleep(800)
     end;
    ID.Visible := False;
    MessageBeep(0);

    ShowCursor(false);
    GetCursorPos(sp);
    SetCursorPos(cx, cy);
    TotalDst := 0;
    while DoCalibrate do
     begin
      Show;
      GetCursorPos(p);
      dst := DistOf(p.x, p.y, cx, cy);
      SetCursorPos(cx, cy);
      inc(TotalDst, dst);
      PB.Position := dst;
      PixDn.Caption := IntToStr(TotalDst);
      sleep(50);
      Application.ProcessMessages;
     end;
   finally
    DoCalibrate := False;
    ShowCursor(true);
    SetCursorPos(sp.x, sp.y);
    fPixels := TotalDst;
    MouseRes.Caption := Format('1  = %.f .', [TotalDst/10]);

    PB.Position := 0;
   end;
end;

procedure TfCfgFmt.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     DoCalibrate := False;
end;

procedure TfCfgFmt.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then
   begin
    Button1Click(self);
    Key := 0;
   end;
end;

procedure TfCfgFmt.Button8Click(Sender: TObject);
begin
   DoCalibrate := False;
   NB.PageIndex := 0;
end;

procedure TfCfgFmt.Button7Click(Sender: TObject);
begin
   ModalResult := mrOk;
end;

end.

