{ -----------------------------------------------------------------------------
   MouseOffRoad - Mouse Counter for Microsoft Windows.
   Copyright (C) 2000  Alexander Kramarenko <groupstudio@mail.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

History:
   14.05.2000 Released under GNU
   15.05.2000 Bug fixes
------------------------------------------------------------------------------ }

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AKTools, ExtCtrls, StdCtrls, Buttons, uCfg, Menus, RXShell;

type
  TfMain = class(TForm)
    Timer: TTimer;
    PMen: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    tray: TRxTrayIcon;
    Panel1: TPanel;
    FramePanel: TPanel;
    N4: TMenuItem;
    MainPanel: TPanel;
    Pic1: TImage;
    IndPan: TPanel;
    Ttm: TLabel;
    tts: TLabel;
    Tbl: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    N5: TMenuItem;
    N6: TMenuItem;
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure trayClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1DblClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure N4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure trayMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
   procedure StopMouse;
   procedure StartMouse;

   procedure ShowStatus(St:Integer);
   procedure UpdateTopMost;
  end;

var
  fMain: TfMain;

const
  WS_EX_LAYERED = $80000;

  LWA_COLORKEY = 1;
  LWA_ALPHA    = 2;

type
  TSetLayeredWindowAttributes = function(
            hwnd : HWND;         // handle to the layered window
            crKey : TColor;     // specifies the color key
            bAlpha : byte;       // value for the blend function
            dwFlags : DWORD       // action
            ): BOOL; stdcall;

implementation


uses uVariables;

var
  SetLayeredWindowAttributes : TSetLayeredWindowAttributes;


var pX1, pY1: Integer;

{$R *.DFM}
{$R MouseOffRoad.res}



procedure TfMain.StartMouse;
var p : TPoint;
begin
   ReadConfig;
   Left := LabelX;
   Top := LabelY;

   UpdateTopMost;
   Timer.Enabled := True;

   ShowStatus(999);
   GetCursorPos(p); pX1 := p.x; pY1 := p.y;

   PMen.Items[1].Checked := MostTopWindow;
end;

procedure TfMain.StopMouse;
begin
   Timer.Enabled := False;
   SaveConfig;
end;

procedure TfMain.TimerTimer(Sender: TObject);
const tme:Integer = 0;
      sec:Integer = 0;
      sleep:Integer = 0;
var p : TPoint;
    st: String;
    dst : Integer;
begin
  try
   if (Left < 5) and (Left > -5) then Left := 0;
   if (Top < 5) and (Top > -5) then Top := 0;
   if (Left + Width > Screen.Width - 5) and
      (Left + Width < Screen.Width + 5) then
    Left := Screen.Width - Width;
   if (Top + Height > Screen.Height - 5) and
      (Top + Height < Screen.Height + 5) then
    Top := Screen.Height - Height;

   MainPanel.Color := Colors[ColorSch];

   GetCursorPos(p);
   dst := trunc(DistOf(p.x, p.y, pX1, pY1));
   inc(Distance, dst);

   if dst = 0 then inc(sleep)
              else sleep := 0;

   if sleep < SleepTime * 10 then
    begin
      ShowStatus(0);
      Caption := IntToStr(TotalTime);
      inc(sec); if sec > 9 then begin inc(TotalTime); sec := 0; end;

      tbl.Caption := GetValue(GV_TOTALDISTANCE);
      ttm.Caption := GetValue(GV_TOTALTIME);
      tts.Caption := GetValue(GV_AVGSPEED);

      inc(tme);
      if tme > 10 * SaveConf then
       begin
        SaveConfig;
        tme := 0;
       end;
    end
   else
    ShowStatus(ST_SLEEP);

   pX1 := p.x; pY1 := p.y;
  except {} end;
end;

procedure TfMain.FormCreate(Sender: TObject);
begin
     StartMouse;
end;

procedure TfMain.FormDestroy(Sender: TObject);
begin
     StopMouse;
end;

procedure TfMain.ShowStatus(St: Integer);
const LastStatus: Integer = 0;
begin
  if LastStatus = St then exit;
  LastStatus := St;

   with Pic1.Picture.Bitmap do
    case st of
     ST_SLEEP :
      begin
       LoadFromResourceName(hInstance, 'ICNSTOP');
       tbl.Font.Color := clRed;
      end;
    else
     begin
      LoadFromResourceName(hInstance, 'ICNGO');
      tbl.Font.Color := clYellow;
     end;
    end;
end;

procedure TfMain.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
  SC_DragMove = $F012;  { a magic number }
begin
  ReleaseCapture;
  Perform(WM_SysCommand, SC_DragMove, 0);
end;

procedure TfMain.N1Click(Sender: TObject);
begin
  try
   with TfCfg.Create(nil) do
    try
     tray.PopupMenu := nil;
     ReadAutorunSt;
     if ShowModal = mrOk then
      SaveConfig;
     WriteAutorunSt;
    finally
     tray.PopupMenu := PMen;
     Free;
    end;
  except {} end;  
end;

procedure TfMain.N3Click(Sender: TObject);
begin
     Close;
end;

procedure TfMain.trayClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowWnd := true;
  UpdateTopMost;
end;

procedure TfMain.UpdateTopMost;
var cl :TColor;
begin
  Show;

  cl := Panel1.Color;
  if ShowWnd then Panel1.Color := clLime
             else Panel1.Color := clRed;
  Application.ProcessMessages;
  Sleep(300);
  Panel1.Color := cl;

  try
   if ShowWnd then
    begin
     if MostTopWindow then
      FormStyle := fsStayOnTop
     else
     FormStyle := fsNormal;
    end
   else Hide;
  except {   ,   } end;
end;

procedure TfMain.Panel1DblClick(Sender: TObject);
begin
   ShowWnd := false;
   UpdateTopMost;
end;

procedure TfMain.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
     Resize := false;
end;

procedure TfMain.N4Click(Sender: TObject);
begin
     TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
     MostTopWindow := TMenuItem(Sender).Checked;
     UpdateTopMost;
end;

procedure TfMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     LabelX := Left;
     LabelY := Top;
end;

procedure TfMain.FormShow(Sender: TObject);
var mh : HINST;
  h:Integer;
begin
 h := FindWindow(nil, PChar(Application.Title));
 ShowWindow(h, SW_HIDE);

 if FirstRun then N1Click(sender);

 if TranspPerc <> 100 then
  begin
   mh := GetModuleHandle('user32.dll');
   @SetLayeredWindowAttributes := GetProcAddress(mh, 'SetLayeredWindowAttributes');
   if @SetLayeredWindowAttributes <> nil then
   begin
     SetWindowLong(Handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE) or WS_EX_LAYERED);
     SetLayeredWindowAttributes(Handle, 0, Round(TranspPerc/100*255), LWA_ALPHA);
    end;
  end;
end;

procedure TfMain.trayMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  tray.hint := '  : '+GetValue(GV_TOTALDISTANCE);
end;

end.
